image: openjdk:8-jdk-slim

variables:
  MAVEN_OPTS: "-Dmaven.repo.local=.m2/repository -Dhttps.protocols=TLSv1.2 -Dmaven.color=false -Dorg.slf4j.simpleLogger.log.org.apache.maven.cli.transfer.Slf4jMavenTransferListener=WARN -Dorg.slf4j.simpleLogger.showDateTime=true -Djava.awt.headless=true"
  MAVEN_CLI_OPTS: "--batch-mode --errors --fail-at-end --show-version -DinstallAtEnd=true -DdeployAtEnd=true"

stages:
  - tests
  - install
  - build
  - security

before_script:
  - chmod +x mvnw



dependency_scanning:
  image: docker:stable
  stage: security
  variables:
    DOCKER_HOST: tcp://docker:2375
    DOCKER_DRIVER: overlay2
    DOCKER_TLS_CERTDIR: ""
  allow_failure: true
  services:
    - docker:stable-dind
  script:
    - export SP_VERSION=$(echo "$CI_SERVER_VERSION" | sed 's/^\([0-9]*\)\.\([0-9]*\).*/\1-\2-stable/')
    - docker run
      --env DEP_SCAN_DISABLE_REMOTE_CHECKS="${DEP_SCAN_DISABLE_REMOTE_CHECKS:-false}"
      --volume "$PWD:/code"
      --volume /var/run/docker.sock:/var/run/docker.sock
      "registry.gitlab.com/gitlab-org/security-products/dependency-scanning:$SP_VERSION" /code
  artifacts:
    paths:
      - gl-dependency-scanning-report.json
    reports:
      dependency_scanning: gl-dependency-scanning-report.json

dependencies:
  stage: install
  cache:
    paths:
      - .m2/repository/
    key: "$CI_PIPELINE_ID"
    policy: push
  script:
    - ./mvnw $MAVEN_CLI_OPTS dependency:resolve

build:
  stage: build
  cache:
    paths:
      - .m2/repository/
    key: "$CI_PIPELINE_ID"
    policy: pull
  script:
    - ./mvnw $MAVEN_CLI_OPTS clean compile jib:build

unit:
  variables:
    SCOPE: $CI_JOB_NAME
  stage: tests
  cache:
    paths:
      - .m2/repository/
    key: "$CI_PIPELINE_ID"
    policy: pull
  artifacts:
    paths:
    - target/site/jacoco/*
    expire_in: 1 week
    when: always
    reports:
      junit:
      - target/surefire-reports/TEST-*.xml
      - target/failsafe-reports/TEST-*.xml
  script:
    - ./mvnw $MAVEN_CLI_OPTS test jacoco:report

e2e tests:
  variables:
    SCOPE: $CI_JOB_NAME
  stage: tests
  cache:
    paths:
      - .m2/repository/
    key: "$CI_PIPELINE_ID"
    policy: pull
  script:
    - ./mvnw $MAVEN_CLI_OPTS test
